#include "SendRecvThread.h"
#include "MySyncObject.h"		// CMySyncObjectg

//----------------------------------------------
// function
//    RXgN^
// parameter
//    ConnectionInfoRec *pConInfo	[in]@\ɕKvȏ
// return
//    Ȃ
//----------------------------------------------
CSendRecvThread::CSendRecvThread(ConnectionInfoRec *pConInfo)
{
	m_pConInfo = pConInfo;
	m_fIamZombie = FALSE;
	m_pSendData = NULL;			// Mf[^i[GA
	m_iSendDataSize = 0;		// Mf[^̃TCY
}


//----------------------------------------------
// function
//    fXgN^
// parameter
//    Ȃ
// return
//    Ȃ
//----------------------------------------------
CSendRecvThread::~CSendRecvThread()
{
	SAFE_FREE(m_pSendData)		// Mf[^i[GAJ܂
	m_iSendDataSize = 0;
}

//----------------------------------------------
// function
//    @\Lq֐(DoSendɋLqĂeLq)
// parameter
//    Ȃ
// return
//    0: -1:G[
//----------------------------------------------
UINT CSendRecvThread::DoWork()
{
	BOOL		fRet = TRUE;
	fd_set      wfds;
	struct timeval   tv;
	char		*pcData = NULL;		// Mf[^
	int			iSendSize = 0;		// Mf[^TCY

	while (!m_fStopFlag)
	{
		// M̃f[^ȂΑMf[^邩ׂ
		if (iSendSize == 0)
			iSendSize = GetSendData(&pcData);

		tv.tv_sec = 0;
		tv.tv_usec = 10 * 1000;							// 10msec
		FD_ZERO(&wfds);
		// Mf[^ƂM\pfd_setɃZbg
		if (iSendSize > 0)
			FD_SET(m_pConInfo->fdClient, &wfds);
		select(FD_SETSIZE, NULL, &wfds, NULL, &tv);		// ^CAEg܂SleepƓ
		if (FD_ISSET(m_pConInfo->fdClient, &wfds))		// M\Ȃsend{
		{
			if (send(m_pConInfo->fdClient, pcData, iSendSize, 0) != iSendSize)
			{
				DispErrorMsg("Err:send");
				fRet = FALSE;
				break;
			}
			SAFE_FREE(pcData)							// Mf[^ȂɃZbg
			iSendSize = 0;
		}
	}
	m_pConInfo->pCMySyncObject->Lock();
	m_fIamZombie = TRUE;
	m_pConInfo->pCMySyncObject->UnLock();
	SAFE_FREE(pcData)
	iSendSize = 0;
	return((fRet == TRUE) ? 0 : -1);
}

//----------------------------------------------
// function
//		Mf[^̐ݒ
// parameter
//		char	*pcData	[in]Mf[^
//		int		iSize	[in]f[^
// return
//		TRUE/FALSE
//----------------------------------------------
BOOL CSendRecvThread::SetSendData(char *pcData, int iSize)
{
	BOOL	fRet = FALSE;

	m_pConInfo->pCMySyncObject->Lock();
	// Õf[^ǂ݂ĂȂƂ̓G[ɂ
	if (m_iSendDataSize == 0)
	{
		m_pSendData = (char *)calloc(iSize, sizeof(char));
		memcpy(m_pSendData, pcData, iSize);
		m_iSendDataSize = iSize;
		fRet = TRUE;
	}
	m_pConInfo->pCMySyncObject->UnLock();
	return(fRet);
}

//----------------------------------------------
// function
//		Mf[^̎擾
// parameter
//		char **ppcData	[in/out]Mf[^
// return
//		f[^
//----------------------------------------------
int CSendRecvThread::GetSendData(char **ppcData)
{
	int		iSize = 0;

	m_pConInfo->pCMySyncObject->Lock();
	if (m_iSendDataSize > 0)
	{
		*ppcData = (char *)calloc(m_iSendDataSize, sizeof(char));
		memcpy(*ppcData, m_pSendData, m_iSendDataSize);
		iSize = m_iSendDataSize;
		SAFE_FREE(m_pSendData)		// ǂݏosƂZbg
		m_iSendDataSize = 0;
	}
	m_pConInfo->pCMySyncObject->UnLock();
	return(iSize);
}

//----------------------------------------------
// function
//    ̃Xbh̓]rԂ
//	  ʃXbhQƂ
// parameter
//    Ȃ
// return
//    0: -1:G[
//----------------------------------------------
BOOL CSendRecvThread::IsZombie()
{
	BOOL	fRet;

	m_pConInfo->pCMySyncObject->Lock();
	fRet = m_fIamZombie;
	m_pConInfo->pCMySyncObject->UnLock();
	return(fRet);
}
